#pragma once
#include "dinkyecs.hpp"
#include <deque>

namespace Components {
  struct Player {
    DinkyECS::Entity entity;
  };

  struct Position {
    Point location;
  };

  struct Motion {
    int dx;
    int dy;
  };

  struct Combat {
    int hp;
    int damage;
  };

  struct Treasure {
    int amount;
  };

  struct Tile {
    std::string chr = "!";
  };

  struct ActionLog {
    std::deque<std::string> messages;

    void log(std::string msg) {
      messages.push_front(msg);
      if(messages.size() > 20) {
        messages.pop_back();
      }
    }
  };
}
